// --------------
//
// --------------
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <mmsystem.h>
#include <shellapi.h>
#include <shlobj.h>
#include <richedit.h>
#include <wchar.h>
#include <objbase.h>
#include <ocidl.h>
#include <winuser.h>
#include <olectl.h>
#include <oaidl.h>
#include <ole2.h>
#include <oleauto.h>
#include <conio.h>
#include <direct.h>
#include <ctype.h>
#include <io.h>
#include <math.h>
#include <stdio.h>
#include <string.h>
#include <stddef.h>
#include <stdlib.h>
#include <setjmp.h>
#include <time.h>
#include <stdarg.h>
#include <process.h>


// --------------
// Compiler Defines
// --------------

// LCCWIN32 defs
#if defined( __LCC__ )
  #define USE_LCCWIN32C
#endif

// #define _IGCBOR_
// IGCM + Borland C++ 5.5.1
// #if defined( _IGCBOR_ )
//    // #define HB_OS_WIN_32_USED
//    // #define _WIN32_IE      0x0500
//    // #define _WIN32_WINNT   0x0400
//    // #include <winuser.h>
//    // #include <hbapi.h>
//    // #include <hbapiitm.h>
//    // #include <hbapierr.h>
//    // #include <hbvm.h>
//    // #include <hbstack.h>
// #else
//    // Borland C++ 5.5.1 defs - bcc32.exe
//    #if defined( __BCPLUSPLUS__ )
//      #define strdate _strdate
//      #define USE_BCPLUSPLUS
//      // Borland Libraries
//      #pragma comment(lib,"import32.lib")
//      #pragma comment(lib,"cw32.lib")
//    #endif
//
//    // Borland C
//    #if defined( __BORLANDC__ )
//      #define strdate _strdate
//      #define USE_BORLANDC
//      // Borland Libraries
//      #pragma comment(lib,"import32.lib")
//      #pragma comment(lib,"cw32.lib")
//    #endif
// #endif

#if !defined( __LCC__ )
#else
#endif
// --------------
// Constantes Definidas por usuario
// --------------

#define MNUIMGFLAGS LR_MONOCHROME|LR_LOADREALSIZE
#define MAXWIDTH GetSystemMetrics (SM_CXSCREEN)
#define MAXHEIGHT GetSystemMetrics (SM_CYSCREEN)
#define IDRES_HORIZONAL 100
#define IDRES_VERTICAL 101
#define IDRES_CORNER 102
#define IDHND_HBMP 103
#define IDHND_VBMP 104
#define IDHND_CBMP 105
#define IDVLAYOUT 106
#define IDHLAYOUT 107
#define IDSLAYOUT 108
#define IDH100PX 109
#define IDH150PX 110
#define IDH200PX 111
#define IDH250PX 112
#define IDH300PX 113
#define IDH350PX 114
#define IDH400PX 115
#define IDH450PX 116
#define IDH500PX 117
#define IDH550PX 118
#define IDH600PX 119
#define IDH650PX 120
#define IDH700PX 121
#define IDH750PX 122
#define IDH800PX 123
#define IDHFULL 124
#define IDV100PX 125
#define IDV150PX 126
#define IDV200PX 127
#define IDV250PX 128
#define IDV300PX 129
#define IDV350PX 130
#define IDV400PX 131
#define IDV450PX 132
#define IDV500PX 133
#define IDV550PX 134
#define IDV600PX 135
#define IDV650PX 136
#define IDV700PX 137
#define IDV750PX 138
#define IDV800PX 139
#define IDVFULL 140
#define ID_TOPLEFT 141
#define IDMNU_EXIT 142
#define IDMNU_IMGL 143
#define IDMNU_IMGH 144
#define IDMNU_IMGV 145
#define IDMNU_IMGT 146
/* added by bcd */
#define IDMNU_ABOUT 147
#define IDMNU_MINI 148
#define IDMNU_MAXI 149
#define IDV30PX 150
#define IDH30PX 151

// --------------
// Variables del sistema
// --------------


// --------------
// User Global Variables
// --------------

static HINSTANCE BCX_hInstance;
static int     BCX_ScaleX;
static int     BCX_ScaleY;
static char    BCX_ClassName[2048];
static long    RULE;
static long    CURRH;
static long    CURRV;
static HWND    frmRule;
static HMENU   mnuRoot;
static HMENU   mnuOptions;
static HMENU   mnuLayout;
static HMENU   mnuHSize;
static HMENU   mnuVSize;
static HBITMAP hVbmp;
static HBITMAP hHbmp;
static HBITMAP hCbmp;
static POINT   pnt;
static RECT    tRect;
static int     x;
static int     y;
static int     w;
static int     h;
static long    q;
/* added by bcd */
static int    hMini;
static int    vMini;


// --------------
// Standard Macros
// --------------

#define Show(Window)RedrawWindow(Window,0,0,0);ShowWindow(Window,SW_SHOW);
#define Hide(Window)ShowWindow(Window,SW_HIDE)


// --------------
// Standard Prototypes
// --------------

#if defined( _IGCBOR_ )
   HWND    BCX_form(char*,int,int,int,int,int,int); // params 7
#else
   HWND    BCX_form(char*,int=0,int=0,int=250,int=150,int=0,int=0);
#endif
#if defined( _IGCBOR_ )
   HWND    BCX_Bitmap(char*,HWND,int,int,int,int,int,int,int,int); // params 10
#else
   HWND    BCX_Bitmap(char*,HWND=0,int=0,int=0,int=0,int=0,int=0,int=0,int=0,int=0);
#endif
#if defined( _IGCBOR_ )
   void    Center (HWND,HWND,HWND);
#else
   void    Center (HWND,HWND=0,HWND=0);
#endif
char*   BCX_TmpStr(size_t);
char*   AppExeName (void);

// --------------
// User Prototypes
// --------------

void    Form_Setup (void);
void    MenuSetup (void);
void    Skin (void);
void    Layout (int);
void    CheckMark (HMENU, long);
void    Nudge (void);
void    ReSizeH (int, int);   /* param 2 added by bcd */
void    ReSizeV (int, int);   /* param 2 added by bcd */
void    TopMost (HWND);
void    PreLoad (void);
BOOL    IsLoaded (char *);
void    FormLoad (void);
void    BCX_Set_Form_Color (HWND,COLORREF);
LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);

  // --------------------------------------------------------------
  //  App:      Screen Ruler v.1.00
  //  Compiler: BCX v3.52b
  //  Author:   Michael S. Sanders
  //  Email:    mjs@nts-online.net
  //  Licnese:  Use as you like understanding if your break anything
  //            you get to keep both pieces |-)
  // --------------------------------------------------------------
// --------------


int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrev,LPSTR CmdLine,int CmdShow)
{
 WNDCLASS Wc;
 MSG      Msg;
 INITCOMMONCONTROLSEX iccex;
// RECT rc          =  {0,0,4,8};
 strcpy(BCX_ClassName,"Screen Ruler");
 // Programmer has selected to use pixels
 BCX_ScaleX       = 1;
 BCX_ScaleY       = 1;
 BCX_hInstance    = hInst;
 Wc.style         = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
 Wc.lpfnWndProc   = WndProc;
 Wc.cbClsExtra    = 0;
 Wc.cbWndExtra    = 0;
 Wc.hInstance     = hInst;
 Wc.hIcon         = LoadIcon(hInst,MAKEINTRESOURCE(99));
 Wc.hCursor       = LoadCursor(NULL,IDC_ARROW);
 Wc.hbrBackground = (HBRUSH)(CreateSolidBrush(255));
 Wc.lpszMenuName  = NULL;
 Wc.lpszClassName = BCX_ClassName;
 iccex.dwSize     = sizeof(INITCOMMONCONTROLSEX);
 InitCommonControlsEx(&iccex);
 RegisterClass(&Wc);

 FormLoad();

 while(GetMessage(&Msg,NULL,0,0))
   {
    HWND hActiveWindow = GetActiveWindow();
    if(!IsWindow(hActiveWindow) || !IsDialogMessage(hActiveWindow,&Msg))
      {
        TranslateMessage(&Msg);
        DispatchMessage(&Msg);
      }
    }
 return Msg.wParam;
}

#pragma optimize(1)
  // --------------------------------------------------------------
  //  App:      Screen Ruler v.1.00
  //  Compiler: BCX v3.52b
  //  Author:   Michael S. Sanders
  //  Email:    mjs@nts-online.net
  //  Licnese:  Use as you like understanding if your break anything
  //            you get to keep both pieces |-)
  // --------------------------------------------------------------

// --------------
// Run Time Functions
// --------------

char *BCX_TmpStr (size_t Bites)
{
  static int   StrCnt;
  static char *StrFunc[2048];
  StrCnt=(StrCnt + 1) & 2047;
  if(StrFunc[StrCnt]) free (StrFunc[StrCnt]);
  return StrFunc[StrCnt]=(char*)calloc(Bites+128,sizeof(char));
}


char *AppExeName (void)
{
  char *temp = BCX_TmpStr(2048);
  char *strtmp = BCX_TmpStr(2048);
  register int i;
  GetModuleFileName(GetModuleHandle(NULL),temp,2048);
  for(i = strlen(temp); i > 0 ; i--)
   {
     if (temp[i] == 0x5C)
      {
        strcpy(strtmp,&temp[i+1]);
        break;
      }
   }
  return strtmp;
}


void BCX_Set_Form_Color (HWND hWnd, COLORREF Kolor)
{
  HBRUSH hbr=CreateSolidBrush(Kolor);
  DeleteObject((HBRUSH)SetClassLong(hWnd,GCL_HBRBACKGROUND,(DWORD)hbr));
  InvalidateRect (hWnd,NULL,TRUE);
}


void Center (HWND hwnd, HWND Xhwnd, HWND Yhwnd)
{
  RECT rect, rectP;
  int  x, y, width, height;
  int  screenwidth, screenheight;
  if(Xhwnd==0)
    {
      RECT  DesktopArea;
      RECT  rc;
      SystemParametersInfo(SPI_GETWORKAREA,0,&DesktopArea,0);
      GetWindowRect(hwnd,&rc);
      SetWindowPos(hwnd,HWND_TOP,
        ((DesktopArea.right-DesktopArea.left)-(rc.right-rc.left))/2+
          DesktopArea.left,((DesktopArea.bottom-DesktopArea.top)-
         (rc.bottom-rc.top))/2 + DesktopArea.top,0,0,SWP_NOSIZE);
      return;
    }
  GetWindowRect (hwnd,&rect);
  GetWindowRect (Xhwnd,&rectP);
  width = rect.right-rect.left;
  x = ((rectP.right-rectP.left)-width)/2 + rectP.left;
  if(Yhwnd==NULL)
    {
      height = rect.bottom-rect.top;
      y = ((rectP.bottom-rectP.top)-height)/2 + rectP.top;
    }
  else
    {
      GetWindowRect(Yhwnd,&rectP);
      height = rect.bottom-rect.top;
      y = ((rectP.bottom-rectP.top)-height)/2+rectP.top;
    }
  screenwidth = GetSystemMetrics(SM_CXSCREEN);
  screenheight = GetSystemMetrics(SM_CYSCREEN);
  if ((x<0)) x=0;
  if ((y<0)) y=0;
  if ((x+width>screenwidth))   x = screenwidth-width;
  if ((y+height>screenheight)) y = screenheight-height;
  MoveWindow (hwnd, x, y, width, height, FALSE);
}


HWND BCX_form
(char *Caption,
 int X,
 int Y,
 int W,
 int H,
 int Style,
 int Exstyle)
{
   HWND  A;
   if(!Style)
     {
        Style= WS_MINIMIZEBOX  |
        WS_SIZEBOX      |
        WS_CAPTION      |
        WS_MAXIMIZEBOX  |
        WS_POPUP        |
        WS_SYSMENU;
     }
   A = CreateWindowEx(Exstyle,BCX_ClassName,Caption,
   Style,
   X*BCX_ScaleX,
   Y*BCX_ScaleY,
   (4+W)*BCX_ScaleX,
   (12+H)*BCX_ScaleY,
   NULL,(HMENU)NULL,BCX_hInstance,NULL);
   SendMessage(A,(UINT)WM_SETFONT,(WPARAM)GetStockObject
   (DEFAULT_GUI_FONT),(LPARAM)MAKELPARAM(FALSE,0));
   return A;
}


HWND BCX_Bitmap
(char* Text,HWND hWnd,int id,int X,int Y,int W,int H,int Res,int Style,int Exstyle)
{
  HWND A;
  HBITMAP hBitmap;
   if(!Style) Style=WS_CLIPSIBLINGS|WS_CHILD|WS_VISIBLE|SS_BITMAP|WS_TABSTOP;
   A = CreateWindowEx(Exstyle,"static",NULL,Style,
                      X*BCX_ScaleX, Y*BCX_ScaleY, 0, 0,
                      hWnd,(HMENU)id,BCX_hInstance,NULL);
   if(!Res)
     hBitmap=(HBITMAP)LoadImage(0,Text,IMAGE_BITMAP,0,0,
                                LR_LOADFROMFILE|LR_CREATEDIBSECTION);
   else
     hBitmap=(HBITMAP)LoadImage(GetModuleHandle(0),MAKEINTRESOURCE(Res),
                                IMAGE_BITMAP,0,0,LR_CREATEDIBSECTION);
  if(W||H) hBitmap=(HBITMAP)CopyImage(hBitmap,IMAGE_BITMAP,W*BCX_ScaleX,H*BCX_ScaleY,LR_COPYRETURNORG);
  SendMessage(A,(UINT)STM_SETIMAGE,(WPARAM)IMAGE_BITMAP,(LPARAM)hBitmap);
  if(W||H) SetWindowPos(A,HWND_TOP,X*BCX_ScaleX,Y*BCX_ScaleY,W*BCX_ScaleX,H*BCX_ScaleY,SWP_DRAWFRAME);
  return A;
}



// --------------
// User Subs and Functions
// --------------


void Form_Setup (void)
  {
    // --------------------------------------------------------------
    frmRule= BCX_form("Screen Ruler",0,0,3051,3051,WS_POPUP,WS_EX_TOOLWINDOW);
    hCbmp=BCX_Bitmap("",frmRule,IDHND_CBMP,0,0,21,21,IDRES_CORNER);
    hHbmp=BCX_Bitmap("",frmRule,IDHND_HBMP,0,0,3051,21,IDRES_HORIZONAL);
    hVbmp=BCX_Bitmap("",frmRule,IDHND_VBMP,0,0,21,3051,IDRES_VERTICAL);
  }


void MenuSetup (void)
{
  // --------------------------------------------------------------
  static  HBITMAP  mnuImgL;
  memset(&mnuImgL,0,sizeof(mnuImgL));
  static  HBITMAP  mnuImgH;
  memset(&mnuImgH,0,sizeof(mnuImgH));
  static  HBITMAP  mnuImgV;
  memset(&mnuImgV,0,sizeof(mnuImgV));
  static  HBITMAP  mnuImgT;
  memset(&mnuImgT,0,sizeof(mnuImgT));
  mnuRoot=CreateMenu();
  mnuOptions=CreateMenu();
  mnuLayout=CreateMenu();
  mnuHSize=CreateMenu();
  mnuVSize=CreateMenu();
  //  Create Layout submenu items
  InsertMenu(mnuOptions,0,MF_POPUP,(UINT)mnuLayout,"&Layout");
  AppendMenu(mnuLayout,MF_STRING,IDHLAYOUT,"&Horizontal");
  AppendMenu(mnuLayout,MF_STRING,IDVLAYOUT,"&Vertical");
  AppendMenu(mnuLayout,MF_STRING,IDSLAYOUT,"&Square");
  //  Create Size submenu items
  InsertMenu(mnuOptions,1,MF_POPUP,(UINT)mnuHSize,"&HSize");
  AppendMenu(mnuHSize,MF_STRING,IDH100PX,"&100 px");
  AppendMenu(mnuHSize,MF_STRING,IDH150PX,"1&50 px");
  AppendMenu(mnuHSize,MF_STRING,IDH200PX,"&200 px");
  AppendMenu(mnuHSize,MF_STRING,IDH250PX,"2&50 px");
  AppendMenu(mnuHSize,MF_STRING,IDH300PX,"&300 px");
  AppendMenu(mnuHSize,MF_STRING,IDH350PX,"3&50 px");
  AppendMenu(mnuHSize,MF_STRING,IDH400PX,"&400 px");
  AppendMenu(mnuHSize,MF_STRING,IDH450PX,"4&50 px");
  AppendMenu(mnuHSize,MF_STRING,IDH500PX,"&500 px");
  AppendMenu(mnuHSize,MF_STRING,IDH550PX,"5&50 px");
  AppendMenu(mnuHSize,MF_STRING,IDH600PX,"&600 px");
  AppendMenu(mnuHSize,MF_STRING,IDH650PX,"6&50 px");
  AppendMenu(mnuHSize,MF_STRING,IDH700PX,"&700 px");
  AppendMenu(mnuHSize,MF_STRING,IDH750PX,"7&50 px");
  AppendMenu(mnuHSize,MF_STRING,IDH800PX,"&800 px");
  AppendMenu(mnuHSize,MF_SEPARATOR,0,"");
  AppendMenu(mnuHSize,MF_STRING,IDHFULL,"&Screen Width");
  InsertMenu(mnuOptions,2,MF_POPUP,(UINT)mnuVSize,"&VSize");
  AppendMenu(mnuVSize,MF_STRING,IDV100PX,"&100 px");
  AppendMenu(mnuVSize,MF_STRING,IDV150PX,"1&50 px");
  AppendMenu(mnuVSize,MF_STRING,IDV200PX,"&200 px");
  AppendMenu(mnuVSize,MF_STRING,IDV250PX,"2&50 px");
  AppendMenu(mnuVSize,MF_STRING,IDV300PX,"&300 px");
  AppendMenu(mnuVSize,MF_STRING,IDV350PX,"3&50 px");
  AppendMenu(mnuVSize,MF_STRING,IDV400PX,"&400 px");
  AppendMenu(mnuVSize,MF_STRING,IDV450PX,"4&50 px");
  AppendMenu(mnuVSize,MF_STRING,IDV500PX,"&500 px");
  AppendMenu(mnuVSize,MF_STRING,IDV550PX,"5&50 px");
  AppendMenu(mnuVSize,MF_STRING,IDV600PX,"&600 px");
  AppendMenu(mnuVSize,MF_STRING,IDV650PX,"6&50 px");
  AppendMenu(mnuVSize,MF_STRING,IDV700PX,"&700 px");
  AppendMenu(mnuVSize,MF_STRING,IDV750PX,"7&50 px");
  AppendMenu(mnuVSize,MF_STRING,IDV800PX,"&800 px");
  AppendMenu(mnuVSize,MF_SEPARATOR,0,"");
  AppendMenu(mnuVSize,MF_STRING,IDVFULL,"&Screen Height");
  AppendMenu(mnuOptions,MF_STRING,ID_TOPLEFT,"&Top Left");
  AppendMenu(mnuOptions,MF_SEPARATOR,0,"");
  /* added by bcd */
  AppendMenu(mnuOptions,MF_STRING,IDMNU_MINI,"Minimize");
  AppendMenu(mnuOptions,MF_STRING,IDMNU_MAXI,"Restore");
  AppendMenu(mnuOptions,MF_SEPARATOR,0,"");
  AppendMenu(mnuOptions,MF_STRING,IDMNU_ABOUT,"About");

  AppendMenu(mnuOptions,MF_SEPARATOR,0,"");
  AppendMenu(mnuOptions,MF_STRING,IDMNU_EXIT,"E&xit");

  mnuImgL=LoadImage(BCX_hInstance,MAKEINTRESOURCE(IDMNU_IMGL),IMAGE_BITMAP,0,0,MNUIMGFLAGS);
  SetMenuItemBitmaps(mnuOptions,0,MF_BYPOSITION,mnuImgL,0);
  mnuImgH=LoadImage(BCX_hInstance,MAKEINTRESOURCE(IDMNU_IMGH),IMAGE_BITMAP,0,0,MNUIMGFLAGS);
  SetMenuItemBitmaps(mnuOptions,1,MF_BYPOSITION,mnuImgH,0);
  mnuImgV=LoadImage(BCX_hInstance,MAKEINTRESOURCE(IDMNU_IMGV),IMAGE_BITMAP,0,0,MNUIMGFLAGS);
  SetMenuItemBitmaps(mnuOptions,2,MF_BYPOSITION,mnuImgV,0);
  mnuImgT=LoadImage(BCX_hInstance,MAKEINTRESOURCE(IDMNU_IMGT),IMAGE_BITMAP,0,0,MNUIMGFLAGS);
  SetMenuItemBitmaps(mnuOptions,3,MF_BYPOSITION,mnuImgT,0);
  //  Attach menu items to main menu
  InsertMenu(mnuRoot,0,MF_POPUP,(UINT)mnuOptions,"");
}


void Skin (void)
{
  // --------------------------------------------------------------
  static  HRGN  hRgnOuter;
  memset(&hRgnOuter,0,sizeof(hRgnOuter));
  static  HRGN  hRgnInner;
  memset(&hRgnInner,0,sizeof(hRgnInner));
  static  HRGN  hRgnComb;
  memset(&hRgnComb,0,sizeof(hRgnComb));
  GetWindowRect(frmRule,&tRect);
  h=tRect.bottom-tRect.top;
  w=tRect.right-tRect.left;
  hRgnComb=CreateRectRgn(0,0,0,0);
  hRgnOuter=CreateRectRgn(tRect.left,tRect.top,w,h);
  hRgnInner=CreateRectRgn(tRect.left+21,tRect.top+21,w,h);
  CombineRgn(hRgnComb,hRgnOuter,hRgnInner,RGN_DIFF);
  SetWindowRgn(frmRule,hRgnComb,FALSE);
  SetWindowPos(frmRule,0,0,0,w,h,SWP_NOMOVE|SWP_NOZORDER);
  InvalidateRgn(frmRule,hRgnComb,FALSE);
  DeleteObject(hRgnComb);
  DeleteObject(hRgnOuter);
  DeleteObject(hRgnInner);
}


void Layout (int Mode)
{
  // --------------------------------------------------------------
  GetWindowRect(frmRule,&tRect);
  w=tRect.right-tRect.left;
  h=tRect.bottom-tRect.top;
  while(1)
  {
  if(Mode==0)
    {
      if(RULE==0)
        {
          return;
        }
      // If RULE = 1 Then ReSizeH(h -1)
      ReSizeV(20, 0);
      Hide(hVbmp);
      Hide(hCbmp);
      Show(hHbmp);
      //  checkmark horizontal layout
      CheckMenuItem(mnuLayout,IDHLAYOUT,MF_CHECKED);
      CheckMenuItem(mnuLayout,IDVLAYOUT,MF_UNCHECKED);
      CheckMenuItem(mnuLayout,IDSLAYOUT,MF_UNCHECKED);
      //  disable VSize menu
      EnableMenuItem(mnuOptions,2,MF_BYPOSITION|MF_GRAYED);
      //  enable HSize menu
      EnableMenuItem(mnuOptions,1,MF_BYPOSITION|MF_ENABLED);
      //  checkmark current horizontal size
      SendMessage(frmRule,(UINT)WM_COMMAND,(WPARAM)CURRH,(LPARAM)0);
      RULE=0;
      break;
    }
  if(Mode==1)
    {
      if(RULE==1)
        {
          return;
        }
      // If RULE = 0 Then ReSizeV(w -1)
      ReSizeH(20, 0);
      Hide(hHbmp);
      Hide(hCbmp);
      Show(hVbmp);
      //  checkmark vertical layout
      CheckMenuItem(mnuLayout,IDHLAYOUT,MF_UNCHECKED);
      CheckMenuItem(mnuLayout,IDVLAYOUT,MF_CHECKED);
      CheckMenuItem(mnuLayout,IDSLAYOUT,MF_UNCHECKED);
      //  disable HSize menu
      EnableMenuItem(mnuOptions,1,MF_BYPOSITION|MF_GRAYED);
      //  enable VSize menu
      EnableMenuItem(mnuOptions,2,MF_BYPOSITION|MF_ENABLED);
      //  checkmark current vertical size
      SendMessage(frmRule,(UINT)WM_COMMAND,(WPARAM)CURRV,(LPARAM)0);
      RULE=1;
      break;
    }
  if(Mode==2)
    {
      while(1)
      {
      if(RULE==(-1))
        {
          q=351;
          break;
        }
      if(RULE==0)
        {
          q=w;
          break;
        }
      if(RULE==1)
        {
          q=h;
          break;
        }
      if(RULE==2)
        {
          return;
        }
      break;
      }
    SetWindowPos(frmRule,0,0,0,q,q,SWP_NOMOVE|SWP_NOZORDER);
    Show(hHbmp);
    Show(hVbmp);
    Show(hCbmp);
    Nudge();
    //  check mark square layout
    CheckMenuItem(mnuLayout,IDHLAYOUT,MF_UNCHECKED);
    CheckMenuItem(mnuLayout,IDVLAYOUT,MF_UNCHECKED);
    CheckMenuItem(mnuLayout,IDSLAYOUT,MF_CHECKED);
    //  enable both HSize/VSize menus
    EnableMenuItem(mnuOptions,1,MF_BYPOSITION|MF_ENABLED);
    EnableMenuItem(mnuOptions,2,MF_BYPOSITION|MF_ENABLED);
    //  checkmark both current horizontal/vertical size
    SendMessage(frmRule,(UINT)WM_COMMAND,(WPARAM)CURRH,(LPARAM)0);
    SendMessage(frmRule,(UINT)WM_COMMAND,(WPARAM)CURRV,(LPARAM)0);
    RULE=2;
  }
break;
}
}


void CheckMark (HMENU MNU, long ID)
{
  // --------------------------------------------------------------
  while(1)
  {
  if(MNU==mnuHSize)
    {
      for(q=IDH100PX; q<=IDHFULL; q+=1)
        {
          if(q!=ID)
            {
              CheckMenuItem(mnuHSize,q,MF_UNCHECKED);
            }
          else
            {
              CheckMenuItem(MNU,q,MF_CHECKED);
            }
        }
      CURRH=ID;
      break;
    }
  if(MNU==mnuVSize)
    {
      for(q=IDV100PX; q<=IDVFULL; q+=1)
        {
          if(q!=ID)
            {
              CheckMenuItem(mnuVSize,q,MF_UNCHECKED);
            }
          else
            {
              CheckMenuItem(MNU,q,MF_CHECKED);
            }
        }
      CURRV=ID;
    }
  break;
  }
}


void Nudge (void)
{
  // --------------------------------------------------------------
  GetWindowRect(frmRule,&tRect);
  w=tRect.right-tRect.left;
  if((w+tRect.left)>MAXWIDTH)
    {
      SetWindowPos(frmRule,0,MAXWIDTH-w,tRect.top,0,0,SWP_NOSIZE|SWP_NOZORDER);
    }
  GetWindowRect(frmRule,&tRect);
  h=tRect.bottom-tRect.top;
  if((tRect.top+h)>MAXHEIGHT)
    {
      SetWindowPos(frmRule,0,tRect.left,MAXHEIGHT-h,0,0,SWP_NOSIZE|SWP_NOZORDER);
    }
  GetWindowRect(frmRule,&tRect);
  if(tRect.left<0)
    {
      SetWindowPos(frmRule,0,0,tRect.top,0,0,SWP_NOSIZE|SWP_NOZORDER);
    }
  GetWindowRect(frmRule,&tRect);
  if(tRect.top<0)
    {
      SetWindowPos(frmRule,0,tRect.left,0,0,0,SWP_NOSIZE|SWP_NOZORDER);
    }
}


void ReSizeH (int iWidth, int iGrabar)
{
  // --------------------------------------------------------------
  /* added by bcd */
  if ( iGrabar )
     hMini = iWidth;

  GetWindowRect(frmRule,&tRect);
  w=iWidth+1;
  h=tRect.bottom-tRect.top;
  SetWindowPos(frmRule,0,0,0,w,h,SWP_NOMOVE|SWP_NOZORDER);
  Nudge();
}


void ReSizeV (int iHeight, int iGrabar)
{
  // --------------------------------------------------------------
  /* added by bcd */
  if ( iGrabar )
     vMini = iHeight;

  GetWindowRect(frmRule,&tRect);
  w=tRect.right-tRect.left;
  h=iHeight+1;
  SetWindowPos(frmRule,0,0,0,w,h,SWP_NOMOVE|SWP_NOZORDER);
  Nudge();
}


void TopMost (HWND hWnd)
{
  // --------------------------------------------------------------
  SetWindowPos(hWnd,HWND_TOPMOST,0,0,0,0,SWP_NOACTIVATE|SWP_NOSIZE|SWP_NOMOVE);
}


void PreLoad (void)
{
  // --------------------------------------------------------------
  if(IsLoaded(AppExeName()))
    {
      MessageBox (GetActiveWindow(),"Another instance of Screen Ruler detected - aborting","Already loaded!",MB_OK);
      ExitProcess(0);
    }
}


BOOL IsLoaded (char *UniqueId)
{
  // --------------------------------------------------------------
  //  Mutex's are automatically closed/deleted
  //  when the creating process terminates
  // CONSTant MUTEX_ALL_ACCESS = 0x1f0001
  // DIM hMtx As HANDLE
  if(OpenMutex(MUTEX_ALL_ACCESS,0,UniqueId)!=0)
    {
      return TRUE;
    }
  else
    {
      CreateMutex(0,1,UniqueId);
      return FALSE;
    }
}


void FormLoad (void)
{
  // --------------------------------------------------------------
  RULE=(-1);
  CURRH=IDH350PX;
  CURRV=IDV350PX;
  //  start building our frmRule
  Form_Setup();
  MenuSetup();
  //  load initial settings
  Skin();
  Layout(2);
  CheckMenuItem(mnuHSize,IDH350PX,MF_CHECKED);
  CheckMenuItem(mnuVSize,IDV350PX,MF_CHECKED);
  CheckMenuItem(mnuLayout,IDSLAYOUT,MF_CHECKED);
  //  lets rock!
  Center (frmRule);
  TopMost(frmRule);
  BCX_Set_Form_Color(frmRule,RGB(255,0,0));
  Show(frmRule);
}


LRESULT CALLBACK WndProc (HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
  // --------------------------------------------------------------
  while(1)
  {
  if(Msg==WM_CREATE)
    {
      PreLoad();
      break;
    }
  if(Msg==WM_CONTEXTMENU)
    {
      GetCursorPos(&pnt);
      TrackPopupMenuEx(mnuOptions,TPM_LEFTALIGN|TPM_RIGHTBUTTON,pnt.x,pnt.y,hWnd,NULL);
      PostMessage(frmRule,WM_NULL,0,0);
      break;
    }
  if(Msg==WM_LBUTTONDOWN)
    {
      SetCapture(frmRule);
      x=LOWORD(lParam);
      y=HIWORD(lParam);
      break;
    }
  if(Msg==WM_MOUSEMOVE)
    {
      if(wParam==MK_LBUTTON)
        {
          GetCursorPos(&pnt);
          SetWindowPos(frmRule,0,pnt.x-x,pnt.y-y,0,0,SWP_NOSIZE|SWP_NOZORDER);
        }
      break;
    }
  if(Msg==WM_LBUTTONUP||Msg==WM_RBUTTONUP)
    {
      ReleaseCapture();
      Nudge();
      break;
    }
  if(Msg==WM_COMMAND)
    {
      while(1)
      {
      if(LOWORD(wParam)==IDMNU_EXIT)
        {
          SendMessage(frmRule,(UINT)WM_CLOSE,(WPARAM)0,(LPARAM)0);
          break;
        }
      /* added by bcd */
      if(LOWORD(wParam)==IDMNU_ABOUT)
        {
          MessageBox (GetActiveWindow(),"copyright Michael Sanders. BCX","Ruler",0);
          break;
        }
      /* added by bcd */
      if(LOWORD(wParam)==IDMNU_MINI)
        {
          ReSizeV(30, 0);
          ReSizeH(30, 0);
          SetWindowPos(frmRule,0,0,0,w,h,SWP_NOSIZE|SWP_NOZORDER);
          break;
        }
      /* added by bcd */
      if(LOWORD(wParam)==IDMNU_MAXI)
        {
          ReSizeV(vMini, 0);
          ReSizeH(hMini, 0);
          SetWindowPos(frmRule,0,0,0,w,h,SWP_NOSIZE|SWP_NOZORDER);
          break;
        }

      if(LOWORD(wParam)==IDH100PX)
        {
          ReSizeH(100, 1 );
          CheckMark(mnuHSize,IDH100PX);
          break;
        }
      if(LOWORD(wParam)==IDH150PX)
        {
          ReSizeH(150, 1 );
          CheckMark(mnuHSize,IDH150PX);
          break;
        }
      if(LOWORD(wParam)==IDH200PX)
        {
          ReSizeH(200, 1 );
          CheckMark(mnuHSize,IDH200PX);
          break;
        }
      if(LOWORD(wParam)==IDH250PX)
        {
          ReSizeH(250, 1 );
          CheckMark(mnuHSize,IDH250PX);
          break;
        }
      if(LOWORD(wParam)==IDH300PX)
        {
          ReSizeH(300, 1 );
          CheckMark(mnuHSize,IDH300PX);
          break;
        }
      if(LOWORD(wParam)==IDH350PX)
        {
          ReSizeH(350, 1 );
          CheckMark(mnuHSize,IDH350PX);
          break;
        }
      if(LOWORD(wParam)==IDH400PX)
        {
          ReSizeH(400, 1 );
          CheckMark(mnuHSize,IDH400PX);
          break;
        }
      if(LOWORD(wParam)==IDH450PX)
        {
          ReSizeH(450, 1 );
          CheckMark(mnuHSize,IDH450PX);
          break;
        }
      if(LOWORD(wParam)==IDH500PX)
        {
          ReSizeH(500, 1 );
          CheckMark(mnuHSize,IDH500PX);
          break;
        }
      if(LOWORD(wParam)==IDH550PX)
        {
          ReSizeH(550, 1 );
          CheckMark(mnuHSize,IDH550PX);
          break;
        }
      if(LOWORD(wParam)==IDH600PX)
        {
          ReSizeH(600, 1 );
          CheckMark(mnuHSize,IDH600PX);
          break;
        }
      if(LOWORD(wParam)==IDH650PX)
        {
          ReSizeH(650, 1 );
          CheckMark(mnuHSize,IDH650PX);
          break;
        }
      if(LOWORD(wParam)==IDH700PX)
        {
          ReSizeH(700, 1 );
          CheckMark(mnuHSize,IDH700PX);
          break;
        }
      if(LOWORD(wParam)==IDH750PX)
        {
          ReSizeH(750, 1 );
          CheckMark(mnuHSize,IDH750PX);
          break;
        }
      if(LOWORD(wParam)==IDH800PX)
        {
          ReSizeH(800, 1 );
          CheckMark(mnuHSize,IDH800PX);
          break;
        }
      if(LOWORD(wParam)==IDHFULL)
        {
          ReSizeH(MAXWIDTH, 1 );
          CheckMark(mnuHSize,IDHFULL);
          // --
          break;
        }

      /* added by bcd */
      if(LOWORD(wParam)==IDH30PX)
        {
          ReSizeH(30, 0 );
          break;
        }
      if(LOWORD(wParam)==IDV30PX)
        {
          ReSizeV(30, 0);
          break;
        }

      if(LOWORD(wParam)==IDV100PX)
        {
          ReSizeV(100, 1 );
          CheckMark(mnuVSize,IDV100PX);
          break;
        }
      if(LOWORD(wParam)==IDV150PX)
        {
          ReSizeV(150, 1 );
          CheckMark(mnuVSize,IDV150PX);
          break;
        }
      if(LOWORD(wParam)==IDV200PX)
        {
          ReSizeV(200, 1 );
          CheckMark(mnuVSize,IDV200PX);
          break;
        }
      if(LOWORD(wParam)==IDV250PX)
        {
          ReSizeV(250, 1 );
          CheckMark(mnuVSize,IDV250PX);
          break;
        }
      if(LOWORD(wParam)==IDV300PX)
        {
          ReSizeV(300, 1 );
          CheckMark(mnuVSize,IDV300PX);
          break;
        }
      if(LOWORD(wParam)==IDV350PX)
        {
          ReSizeV(350, 1 );
          CheckMark(mnuVSize,IDV350PX);
          break;
        }
      if(LOWORD(wParam)==IDV400PX)
        {
          ReSizeV(400, 1 );
          CheckMark(mnuVSize,IDV400PX);
          break;
        }
      if(LOWORD(wParam)==IDV450PX)
        {
          ReSizeV(450, 1 );
          CheckMark(mnuVSize,IDV450PX);
          break;
        }
      if(LOWORD(wParam)==IDV500PX)
        {
          ReSizeV(500, 1 );
          CheckMark(mnuVSize,IDV500PX);
          break;
        }
      if(LOWORD(wParam)==IDV550PX)
        {
          ReSizeV(550, 1 );
          CheckMark(mnuVSize,IDV550PX);
          break;
        }
      if(LOWORD(wParam)==IDV600PX)
        {
          ReSizeV(600, 1 );
          CheckMark(mnuVSize,IDV600PX);
          break;
        }
      if(LOWORD(wParam)==IDV650PX)
        {
          ReSizeV(650, 1 );
          CheckMark(mnuVSize,IDV650PX);
          break;
        }
      if(LOWORD(wParam)==IDV700PX)
        {
          ReSizeV(700, 1 );
          CheckMark(mnuVSize,IDV700PX);
          break;
        }
      if(LOWORD(wParam)==IDV750PX)
        {
          ReSizeV(750, 1 );
          CheckMark(mnuVSize,IDV750PX);
          break;
        }
      if(LOWORD(wParam)==IDV800PX)
        {
          ReSizeV(800, 1 );
          CheckMark(mnuVSize,IDV800PX);
          break;
        }
      if(LOWORD(wParam)==IDVFULL)
        {
          ReSizeV(MAXHEIGHT, 1 );
          CheckMark(mnuVSize,IDVFULL);
          break;
        }
      if(LOWORD(wParam)==IDHLAYOUT)
        {
          Layout(0);
          break;
        }
      if(LOWORD(wParam)==IDVLAYOUT)
        {
          Layout(1);
          break;
        }
      if(LOWORD(wParam)==IDSLAYOUT)
        {
          Layout(2);
          break;
        }
      if(LOWORD(wParam)==ID_TOPLEFT)
        {
          SetWindowPos(frmRule,0,0,0,w,h,SWP_NOSIZE|SWP_NOZORDER);
        }
      break;
      }
    break;
  }
if(Msg==WM_CLOSE)
  {
    DestroyWindow(frmRule);
    break;
  }
if(Msg==WM_DESTROY)
  {
    PostQuitMessage(0);
  }
break;
}
  // --------------
  if(Msg == WM_DESTROY)
    {
       UnregisterClass(BCX_ClassName,BCX_hInstance);
       PostQuitMessage(0);
    }
 return DefWindowProc(hWnd,Msg,wParam,lParam);
}


